void Multiply(SymTwoDArray& attrInfo, Graph& graph1, Graph& graph2, 
	      int attr)
{
  int dimn = attrInfo.Dimn();
  int basins = graph1.NumBasins(attr);
  assert(dimn == graph1.DomainSz(attr));

  int i, j, b;
  double val = 0.0;
  int begin = attrInfo.Begin();
  int end = attrInfo.End();

  for (b = 0; b < basins; b++)
    {
      //      cout << " Basin " << b << endl;
      for (i = begin; i <= end; i++)
	{			
	  val = 0.0;
	  for (j = begin; j < i; j++)
	  //for (j = begin; j <= i; j++)
	    {
	      val += ((double)(attrInfo.get_fast(j,i,-1)))*graph1.GetWt(j,attr,b);
	    }
	  for (j = i+1; j <= end; j++)
	    {
	      val += ((double)(attrInfo.get_fast(i,j,-1)))*graph1.GetWt(j,attr,b);
	    }
	  graph2.AddWtToNode(i, attr, b, val);
	}
    }
}
