#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include "node.h"
#include "Set.h"
#include "trans_utils.h"
#include "2DArray.h"

// (1) Post-processing algo: Sort the first non-principal basin of each 
// attribute;
// (2) Separate each attribute into a "natural" number of clusters;
// - the natural number is obtained as follows: avg distance between two 
// consecutive values is d_av = (1-(-1))/n_A; If the distance between two 
// consecutive values is greater than \alpha times d_av then split the
// nodes between the two values, and recurse;
// (3) Overlapping clusters: For each attribute measure the number of links
// between it and other clusters. If the number is greater than \beta times
// the random strength, replicate this value to the cluster as well. 

// (4) Form hypergraph clusters. Each attribute has a set of clusters;
// Find the cross-product of all these sets, and retain those which have
// sufficient strength;

void PostProcess(Graph& graph)
{
  int i;
  for (i = 0; i < graph.NumAttrs(); i++)
    graph.ClusterAttribute(i);
}

void ClusterAttribute(int attr)
{
  graph.Sort(attr, NON_PRINC_BASIN);
  graph.Partition(attr, 
}
