#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include "node.h"
#include "Set.h"
#include "trans_utils.h"
#include "2DArray.h"

int count1and2links(   char *inputFile,
		       TwoDArrayColln& countColln
#ifdef ASCII
		       ,int numItems, int minSupport
#endif
		       )
{
  int large2Itemsets = 0;
  
#ifdef SAMPLING
  for (int index = 0; index < sampleSize; index++) {
    Set transaction(*sample[index]);
#elif defined(ASCII)
    // Potentially very wasteful but we only need one buffer and set at a time.
    int strSize = MAX_TRANS_BYTES(numItems);
    char buf[strSize];
    
    xfile.getline(buf, strSize);

    while (xfile) {
      Set transaction(buf);
      xfile.getline(buf, strSize);
#else
      int xNumber = 0;
      char buffer[TRANS_BLOCK_SIZE];
      Set transaction(0);
      
      SetupXactScan(inputFile, buffer);
      while (getNextXact(transaction, xNumber, buffer) != -1) 
	{
#endif  // SAMPLING
	  countColln.IncrementCounts(transaction);
	}
      transaction.Nullify();
      return large2Itemsets;
}


TwoDArrayColln* PreProcess(char *inputFile, int numAttrs, int *domSizes)
{
  TwoDArrayColln* countColln = new TwoDArrayColln(numAttrs, domSizes);
  count1and2links(inputFile, *countColln);
  return countColln;
}

