#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>
#include <math.h>
#include "node.h"
#include "Set.h"
#include "globals.h"
#include "globals_catClus.h"
#include "trans_utils.h"
#include "PrefixTree.h"

//extern PrefixTree* driverApriori(char *fname, int numItems, int minSupport);
extern void Algorithm(char *inputFile, int numTuples, int numAttrs, 
		      int *domSizes, Graph& graph1, Graph& graph2, int numIterns);

main(int argc, char **argv)
{
  if (argc < 5)
    {
      cout << "Usage: algo <algNum> <inputfile> <numTuples> <numAttrs> <domSzArr> <basinSz> <numIterns> <minSup>" << endl;
      exit(1);
    }

  char inputFile[MAX_NAME_LENGTH];
  int numTuples;
  int algNum; // which algorithm to run;
  int numA;
  int *domSizes;
  int *basinSzs;
  int numIterns;
  int minSup;
  int i;

  algNum = atoi(argv[1]);
  strcpy(inputFile, argv[2]);
  numTuples = atoi(argv[3]);
  numA = atoi(argv[4]);
  domSizes = new int[numA];
  basinSzs = new int[numA];
  int numItems = 0;
  PrefixTree *pt = NULL;

  for (i = 0; i < numA; i++)
    {
      domSizes[i] = atoi(argv[4+i+1]);
      numItems += domSizes[i];
    }
  basinSzs[0] = atoi(argv[4+numA+1]);
  for (i = 1; i < numA; i++)
    basinSzs[i] = basinSzs[0];

  numIterns = atoi(argv[4+numA+2]);
  minSup = atoi(argv[4+numA+3]);

  /***
  if (1 == algNum)
    {
      pt = driverApriori(inputFile, numItems, minSup);
    } 
  ***/

  // create the graph;
  srand48(1001);
  Graph *graph1 = new Graph(numA, domSizes, basinSzs);
  Graph *graph2 = new Graph(numA, domSizes, basinSzs);

  //graph1->Initialize(RANDOM);
  graph1->Initialize(IDENTITY);
  graph2->Initialize(IDENTITY);
  
  cout << " Iterating..." << endl;
  if (2 == algNum)
    Algorithm(inputFile, numTuples, numA, domSizes, *graph1, *graph2, numIterns);
  else 
    for (i = 0; i < numIterns; i++)
      {
	cout << " Iteration number " << i << endl;
	graph1->TestOrthoNormality();
	graph1->IterateSTIRR(inputFile, graph2, pt);
	
	*graph1 = *graph2;
      }

  //cout << *graph1 << endl;
  delete [] domSizes;
  delete [] basinSzs;
  delete graph1;
  delete graph2;
  /***
  if (1 == algNum)
    delete pt;    
  ***/
}
