/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#ifndef PREFIX_TREE_TYPES_H
#define PREFIX_TREE_TYPES_H

//enum PrefixNodeStatus {candidate, negBorder, large, maximal, small};
enum PrefixNodeStatus {candidate, negBorder, maximal, small, PRESENT_MAXIT, 
		       PRESENT_LARGEIT, ADJUSTED_MAXIT, ADJUSTED_LARGEIT, 
		       TO_BE_ADJUSTED, UNADJUSTABLE_AS_YET};

enum IncCountsAction {allLevels, passLevelOnly };

// candidateOnly requires both joining itemsets to be large,
// whereas nonSmallNegBorder requires both joining itemsets to
// be non-small (small marks dead-end prefixes) and at least
// one of the itemsets to be in the negative border.
enum JoinAction { candidateOnly, nonSmallNegBorder };

enum PruneAction { prune, markNegBorder, markSmall, markLarge };

#endif PREFIX_TREE_TYPES_H
