/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#include <stdlib.h>
#include <fstream.h>

#include "Set.h"
#include "macros.h"
#include "srcFunctions.h"

#include "PrefixTree.h"

int dic(Tree * T[], char * fileName, int numItems)
{
  	ifstream xfile;
	xfile.close();
	xfile.open(fileName);
        if (!xfile)
	{
		cout << "cannot open input file" << fileName << "\n";
		exit (1);
	}


	int nextTransaction = 0; // next transaction to be considered

#ifdef ASCII
    	int strSize = MAX_TRANS_BYTES(numItems);
    	char buf[strSize];

#else
    	int xNumber = 0;

#endif

	// iterater is not meaningful right now. But later on we can make
	// it useful. E.g., it may be used to know how many stops DIC made.
        for (int iterater=1;;iterater++)
        {

		int afterLastStopCount = 0; // remembers how many transactions
					    // have been used since last stop
		if (nextTransaction == 0)
		{
        		xfile.close();
        		xfile.open(fileName);
        		if (!xfile) 
			{
				cout <<	"cannot open input file" << fileName;
				exit(1);
			}
		}

                /* loop and in each iteration, do
                   1. M_transaction_process
                   2. incrementCount

                   exit when M_transaction_process tells you that no dashed
                   node is in the tree
                */

	int lastTransaction;
	lastTransaction = nextTransaction - 1;
	if (lastTransaction < 0)
		lastTransaction = FIRST_TRANSACTION + NUM_TRANSACTIONS - 1;
	T[2]->M_transaction_process(lastTransaction);
	
	if (T[2]->returnNumDash() == 0)
	{
		break;
	}

#ifdef ASCII
	if (nextTransaction == 0)
    		xfile.getline(buf, strSize);

#else
	if (nextTransaction == 0)
    		xfile.read(&xNumber, sizeof(xNumber));

#endif

	while (nextTransaction < FIRST_TRANSACTION + NUM_TRANSACTIONS &&
               afterLastStopCount < NUM_BETWEEN_STOPS &&
	       xfile)
	{

#ifdef ASCII
        	Set transaction(buf);
		T[2]->incrementCounts(transaction);
        	xfile.getline(buf, strSize);
#else
        	xfile.read(&xNumber, sizeof(xNumber));
        	Set transaction(xfile);
		T[2]->incrementCounts(transaction);
        	xfile.read(&xNumber, sizeof(xNumber));
#endif
	
		nextTransaction++;
		afterLastStopCount++;

    	}
		if (nextTransaction == FIRST_TRANSACTION + NUM_TRANSACTIONS)
		nextTransaction = 0;

#ifdef ASCII
    	if ( nextTransaction == 0 && buf[0] != '\0')
        	cerr << "no end of line before end of file in xfile" << endl
             	<< "transaction " << buf << " ignored!" << endl;
#endif

	}// for(iterater)

    return 0;
}
