/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#ifndef __TWODARR_H__
#define __TWODARR_H__

#include <assert.h>

class TwoDArray 
{
private:
  int _dimn1;
  int _dimn2;
  int *_array;

public:
  TwoDArray(int d1, int d2) : _dimn1(d1), _dimn2(d2)
    {
      _array = new int[_dimn1 * _dimn2];
      assert(_array != NULL);
    }
  ~TwoDArray()
    {
      delete [] _array;
    }

  int get(int i, int j)
    {
      return _array[i*_dimn2 + j];
    }
  void set(int i, int j, int val)
    {
      _array[i*_dimn2 + j] = val;
    }
};
#endif
