/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#include <iostream.h>
#include <fstream.h>
#include <stdlib.h>

#include "hashtable.h"
#include "globals.h"

void sort(int numItems, int *arr)
{
  assert(numItems == 3);
  
  int min1, minIndx, i, temp;

  min1 = arr[0];
  minIndx = 0;
  for (i = 1; i < numItems; i++)
    {
      if (min1 > arr[i])
	{
	  minIndx = i;
	  min1 = arr[i];
	}
    }
  temp = arr[0];
  arr[0] = min1;
  arr[minIndx] = temp;

  if (arr[1] > arr[2])
    {
      temp = arr[1];
      arr[1] = arr[2];
      arr[2] = temp;
    }
}

main()
{
  int i;
  int maxItemNum = 10000;
  int numEntries = 5000;
  Set set(0);
  Item arr[3];
  int count;

  HashTable ht(numEntries, COUNTSET);

  set.newArr(3, arr);

  srand(113);
  arr[0] = 0;
  arr[1] = 0;
  arr[2] = 0;

  for (i = 0; i < numEntries; i++)
    {
      arr[0] = rand() % maxItemNum;
      do 
	{
	  arr[1] = rand() % maxItemNum;
	}
      while (arr[1] == arr[0]);
      do
	{
	  arr[2] = rand() % maxItemNum;
	}
      while ((arr[2] == arr[1]) || ( arr[2] == arr[0]));

      count = rand() % 1000;

      cout << set << " : " << count << endl;

      sort(3,arr);
      ht.SearchToWrite(set, count);

      cout << set << " : " << count << endl;
    }
  cout << "Inserted all entries" << endl;
  set.Nullify();
}
