/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#ifndef __GLOBAL_H__
#define __GLOBAL_H__

typedef int TIDType;

const int PAGE_SIZE = 1024;
const int INDIV_TIDLIST_BLKSZ=1000; // when counting individual itemsets;
const int LOWTIDLIST_BLKSZ=10;  // when counting using TIDlists at lower itemsets;
const int BLOCK_SIZE = 10240;
const int TRANS_BLOCK_SIZE = 1024000;
const int MAX_BUFSIZE = 40000;  // total amount available to write TID-lists;
const int SMALL_BLKSZ = 2;  // ???

const bool FALSE=false;
const bool TRUE=true;

const int CLOSED=0;
const int OPEN=1;

const int SUCCESS=1;
const int MAX_NAME_LENGTH = 200;
const int MAX_TID = 10000000;
const int MAX_NUMITS = 2000;
const int MAX_DEL_ITS = 100;
const int MAX_IT_LENGTH = 15;
const int MAX_SETCNT = 10000;
const int MAX_SUPCNT_PERXACT = 100;

const int MAX_INT = 2147483647;
const int END_LIST = MAX_INT;
const int EXISTENCE_ONLY = -1;
const int NOT_COUNTED = -1;

// deviation;
const int SUBSET = -1;
const int SUPERSET = -2;

const double HT_OVHD = 1.5;
const int MATERIALIZED_LEVEL = 2;
enum HTType { TIDLIST, COUNTSET };
enum DISTANCE_TYPE { ABSOLUTE, RELATIVE };
enum AGGFN_TYPE {L1, L_INF};
enum ALGORITHM { MAINTENANCE, DEVIATIONS, BOOTSTRAP, DEVNS_ACTUAL, TRENDS};
#endif

