/*
 * Copyright (c) 1998-1999
 * Venkatesh Ganti
 * University of Wisconsin -- Madison
 * All Rights Reserved.

 * Permission to use, copy, modify and distribute this software and its
 * documentation is hereby granted, provided that both the copyright
 * notice and this permission notice appear in all copies of the
 * software, derivative works or modified versions, and any portions
 * thereof, and that both notices appear in supporting documentation.

 * THE DEMON TEAM AT THE UNIVERSITY OF WISCONSIN-MADISON ALLOWS FREE
 * USE OF THIS SOFTWARE IN ITS "AS IS" CONDITION. WE DISCLAIM ANY
 * LIABILITY OF ANY KIND FOR ANY DAMAGES WHATSOEVER RESULTING FROM
 * THE USE OF THIS SOFTWARE. 
 * VENKATESH GANTI, JOHANNES GEHRKE, AND RAGHU RAMAKRISHNAN COMPRISE
 * THE DEMON TEAM
 */



#include "../inc/Set.h"

int main() {

  const int a0[] = {};
  const int a3[] = {0,3,6};
  const int a7[] = {5,8,10,21,24,30,33};

  Set s0(0);
  Set s5(5);
  Set s10(10);

  Set as0(0, a0);
  Set as3(3, a3);
  Set as7(7, a7);

  ofstream oxfile("/tmp/xfile.tmp");
  for (int i = 1; i <= 10; i++) {
      oxfile.write(&i, sizeof(i));  // Transaction number.
      int k = 10 - i;
      oxfile.write(&k, sizeof(k));  // Number of items in transaction.

      for (int j = 1; j <= k; j++)
	  oxfile.write(&j, sizeof(j));
  }
  oxfile.close();

  ifstream ixfile("/tmp/xfile.tmp");

  int xNumber = 0;
  ixfile.read(&xNumber, sizeof(xNumber));

  while (ixfile) {
      Set transaction(ixfile);
#if 0
      cout << transaction << endl;
#endif
      ixfile.read(&xNumber, sizeof(xNumber));
  }  


  Set ss0(s0);
  Set ss5(s5);
  Set sas0(as0);
  Set sas7(as7);

  Set ss10 = s10;
  Set sas3 = as3;

  Set s;


#if 0  // Checked already
  cout << "s0:\t" << s0 << "s5:\t" << s5 << "s10:\t" << s10 << endl;
  cout << "as0:\t" << as0 << "as3:\t" << as3 << "as7:\t" << as7 << endl;
  cout << "ss0:\t" << ss0 << "ss5:\t" << ss5
       << "sas0:\t" << sas0 << "sas7:\t" << sas7 << endl;
  cout << "ss10:\t" << ss10 << "sas3:\t" << sas3 << "s:\t" << s << endl;
#endif

  s = sas7;
  ss10 = sas3;
  sas3 = sas7;
  as3 = as3;

#if 0  // Checked already
  cout << "s:\t" << s << "ss10:\t" << ss10
       << "sas3:\t" << sas3 << "as3:\t" << as3 << endl;

  cout << "ss10.size() = " << ss10.size()
       << " s.elements(6) = " << s.elements(6) << endl << endl;
#endif

  Item i1, i2;

  as0.insert(2); as0.insert(5); as0.insert(3);
  as0.insert(2); as0.insert(7); as0.insert(3);
  as0.insert(5); as0.insert(10); as0.insert(8);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  as0.insert(19); as0.insert(10); as0.insert(15);
  as0.insert(4); as0.insert(25);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  as0.insert(8);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  as0.insert(1); as0.insert(6);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  as0.yankOut(i1, 0); as0.yankOut(i2, 5);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
  cout << "i1 = " << i1 << " i2 = " << i2 << endl;
#endif

  as0.putBack(i1); as0.putBack(i2);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  as0.yankOut(i1, 11); as0.yankOut(i2, 4);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
  cout << "i1 = " << i1 << " i2 = " << i2 << endl;
#endif

  as0.putBack(i2); as0.putBack(i1);

#if 0  // Checked already
  cout << "as0:\t" << as0 << endl;
#endif

  Set * as0s1 = as0.subset(0,0);

  Set * as0s2 = as0.subset(4,5);

  Set * as0s5 = as0.subset(7,11);

#if 0  // Checked already
  cout << "as0:\t" << as0 << "*as0s1:\t" << *as0s1
       << "*as0s2:\t" << *as0s2 <<"*as0s5:\t" << *as0s5 << endl;
#endif
  
#if 0  // Checked already
  cout << "*as0s1 <= as0: " << (*as0s1 <= as0)
       << "  as0 <= *as0s1: " << (as0 <= *as0s1)
       << "  *as0s5 <= as0: " << (*as0s5 <= as0) << endl
       << "  s0 <= *as0s1: " << (s0 <= *as0s1)
       << "  s0 <= s0: " << (s0 <= s0) << endl;
#endif

  as0s1->insert(48);

#if 0  // Checked already
  cout << "*as0s1 <= as0: " << (*as0s1 <= as0)
       << "  as0 <= *as0s1: " << (as0 <= *as0s1)
       << "  *as0s1 <= *as0s1: " << (*as0s1 <= *as0s1) << endl;
#endif

#if 0  // Checked already
  cout << "*as0s1 == as0: " << (*as0s1 == as0)
       << "  as0 == *as0s1: " << (as0 == *as0s1)
       << "  s0 == s0: " << (s0 == s0) << endl;
#endif

  *as0s1 = as0;

#if 0  // Checked already
  cout << "*as0s1 == as0: " << (*as0s1 == as0)
       << "  as0 == *as0s1: " << (as0 == *as0s1) << endl;
#endif

#if 0  // Checked already
  cout << "s0:\t" << s0 << endl;
#endif

  Set * s0a5 = s0.addElement(5);

#if 0  // Checked already
  cout << "*s0a5:\t" << *s0a5 << endl;
#endif

  Set * s0a59 = s0a5->addElement(9);

#if 0  // Checked already
  cout << "*s0a59:\t" << *s0a59 << endl;
  cout << "s0.member(0): " << s0.member(0)
       << "  s0a5->member(5): " << s0a5->member(5)
       << "  s0a5->member(35): " << s0a5->member(35) << endl
       << "s0a59->member(9): " << s0a59->member(9)
       << "  s0a59->member(5): " << s0a59->member(5)
       << "  s0a59->member(45): " << s0a59->member(45) << endl;
#endif

  s0a59->yankOut(i1, 1);

#if 0  // Checked already
  cout << "*s0a59:\t" << *s0a59 << endl;
#endif
  
#if 0  // Checked already
  cout << "s0a59->member(9): " << s0a59->member(9) << endl;
#endif

  s0a59->putBack(i1);

#if 0  // Checked already
  cout << "*s0a59:\t" << *s0a59 << endl;
#endif
  
#if 0  // Checked already
  cout << "s0a59->member(9): " << s0a59->member(9) << endl;
#endif

  const int a15[] = {2,6,7,23,50};
  const int a16[] = {1,2,6,7,23,50};
  const int a26[] = {2,3,6,7,23,50};
  const int a36[] = {2,3,6,7,23,48};
  const int a17[] = {2,3,6,7,23,50,51};
  

  Set s15(5, a15);
  Set s152 = s15;
  Set s16(6, a16);
  Set s26(6, a26);
  Set s36(6, a36);
  Set s17(7, a17);

#if 0  // Checked already
  cout << "compare(s15, s15): " << compare(s15, s15)
       << "  compare(s152, s15): " << compare(s152, s15)
       << "  compare(s15, s16): " << compare(s15, s16) << endl
       << "compare(s16, s15): " << compare(s16, s15)
       << "  compare(s16, s26): " << compare(s16, s26)
       << "  compare(s26, s16): " << compare(s26, s16) << endl
       << "compare(s26, s17): " << compare(s26, s17)
       << "  compare(s26, s36): " << compare(s26, s36)
       << "  compare(s36, s26): " << compare(s36, s26) << endl;
#endif

  delete as0s1;
  delete as0s2;
  delete as0s5;

  delete s0a5;
  delete s0a59;

  return 0;
}
